﻿

Module Module_SaveLoad

    Friend EventsAreEnabled As Boolean = False

    ' ================================================================================================
    '  Private Read-Write functions
    ' ================================================================================================

    Private Function TabString(ByVal Name As String, _
                              Optional ByVal Value As Double = Double.NaN, _
                              Optional ByVal fmt As String = "") As String

        Dim nTab As Int32 = Math.Max(0, 22 - Name.Length)
        If Double.IsNaN(Value) Then
            Return Name
        Else
            Return Name & "=" & Strings.StrDup(nTab, " ") & Value.ToString(fmt)
        End If
    End Function

    Private Function TabString(ByVal Name As String, _
                                  ByVal Value As Boolean) As String

        Dim nTab As Int32 = Math.Max(0, 22 - Name.Length)

        Return Name & "=" & Strings.StrDup(nTab, " ") & Value.ToString
    End Function

    Private Function TabString(ByVal Name As String, _
                                ByVal Value As String) As String

        Dim nTab As Int32 = Math.Max(0, 22 - Name.Length)

        Return Name & "=" & Strings.StrDup(nTab, " ") & Value
    End Function


    Private Function Val_Double(ByVal l As String) As Double
        Return Val(Replace(l, ",", "."))
    End Function


    Private Function ExtractParamName(ByRef s As String) As String
        ' ------------------------- Returns the first field from begin to the first "=" symbol
        ' -------------------------  and removes it from the string
        Dim i As Integer
        i = InStr(s, "=")
        If i > 0 Then
            ExtractParamName = Trim(Strings.Left(s, i - 1))
            s = Trim(Mid(s, i + 1))
        Else
            ExtractParamName = Trim(s)
            s = ""
        End If
    End Function

    Private Function AssemblyName() As String
        Return System.Reflection.Assembly.GetExecutingAssembly.GetName.Name
    End Function


    ' ==================================================================================================
    '  SAVE LOAD -- Program INI
    ' ==================================================================================================

    Friend Sub Save_INI()
        '
        Dim iniFileName As String = PlatformAdjustedFileName(Application.StartupPath & "\" & AssemblyName() & "_ProgramIni.txt")
        Dim f As System.IO.StreamWriter
        f = IO.File.CreateText(iniFileName)
        '
        f.WriteLine(" Program Params")
        f.WriteLine("===========================================")
        ' ------------------------------------------------------------------------------ FORM BOUNDS
        Dim r As Rectangle
        r = GetFormRectangle(Form1)
        f.WriteLine(TabString("Form1_Top", r.Top))
        f.WriteLine(TabString("Form1_Left", r.Left))
        'f.WriteLine(TabString("ShutDownEnabled", Form1.MyButton_ShutDownEnable.Checked.ToString))
        ' ------------------------------------------------------------------------------
        f.WriteLine(TabString("SendIP", Form1.txt_SendIp.Text))
        f.WriteLine(TabString("SendPort", Form1.txt_SendPort.Text))
        f.WriteLine(TabString("ReceivePort", Form1.txt_ReceivePort.Text))
        '
        f.Close()
    End Sub


    Friend Sub Load_INI()
        EventsAreEnabled = False
        ' ------------------------------------------------------------- default values
        ' ------------------------------------------------------------- 
        Dim l As String
        Dim iniFileName As String = PlatformAdjustedFileName(Application.StartupPath & "\" & AssemblyName() & "_ProgramIni.txt")
        If My.Computer.FileSystem.FileExists(iniFileName) Then
            Dim f As System.IO.StreamReader
            f = IO.File.OpenText(iniFileName)
            Do While Not f.EndOfStream
                l = f.ReadLine()
                Select Case ExtractParamName(l)
                    Case "Form1_Top" : Form1.Top = CInt(Val(l))
                    Case "Form1_Left" : Form1.Left = CInt(Val(l))
                        'Case "ShutDownEnabled" : Form1.MyButton_ShutDownEnable.Checked = l = "True"
                        ' ------------------------------------------------------------------------------
                    Case "SendIP" : Form1.txt_SendIp.Text = l
                    Case "SendPort" : Form1.txt_SendPort.Text = l
                    Case "ReceivePort" : Form1.txt_ReceivePort.Text = l
                End Select
            Loop
            f.Close()
        End If
        LimitFormPosition(Form1)
        '
        EventsAreEnabled = True
    End Sub



End Module
